#
# Makefile to build the Fortran and Python interfaces for matrix
# element files and the demonstration Fortran programs which use
# the interface.
#
#DEBUG_FPY = 
SONAME = qcmatrixio.cpython-34m.so
FNAME = qcmatrixio
LIB = qcmatrix
#I8FLAGS = -i8 -r8
I8FLAGS = -fdefault-integer-8 -fdefault-real-8

all: readmat readmat8 writemat writemat8 $(SONAME)

# clean up data files from the example Gaussian jobs and writemat programs.
clean:
	rm -fr domp2 readmat readmat8 writemat writemat8 *.so *.o *.mat *.dat *.log __pycache__

.F.o:
	gfortran -c -g -O0 $*.F

$(SONAME): $(FNAME).F
	cpp $(FNAME).F $(FNAME).f
	f2py3 -DF2PY_REPORT_ON_ARRAY_COPY=1 -m $(FNAME) $(DEBUG_FPY) -c $(FNAME).f
	rm -f $(FNAME).f

readmat: readmat.F $(FNAME).o $(LIB).o
	gfortran -g -O0 -o readmat readmat.F $(FNAME).o $(LIB).o

writemat: writemat.F $(FNAME).F $(LIB).o
	gfortran -g -O0 -o writemat writemat.F $(FNAME).o $(LIB).o

R8FILES = readmat.F $(FNAME).F $(LIB).F
readmat8: $(R8FILES)
	cat $(R8FILES) >readmat8.F
	gfortran $(I8FLAGS) -DUSE_I8 -g -O0 -o readmat8 readmat8.F
	rm -f readmat8.F

W8FILES = writemat.F $(FNAME).F $(LIB).F
writemat8: $(W8FILES)
	cat $(W8FILES) >writemat8.F
	gfortran $(I8FLAGS) -DUSE_I8 -g -O0 -o writemat8 writemat8.F
	rm -f writemat8.F

